#                                               -*- Autoconf -*-
# Process this file with autoconf to produce a configure script.
AC_INIT([HeLIx+],[1.00],[laggmps.mpg.de])
AC_PREFIX_DEFAULT("./")
HELIBS=""
IPATH=""
LPATH=""
PPFLAGS=""
PPCMD="-fpp"
EXE="helix"
EXEADD=""
IDLPAR=" -m32"
CFLAGS="-O2"
LDFLAGS=" "
SHAREDOBJ=" "
MAKECMD="helix"
DISLINSUB=""

#AC_OUTPUT
AC_CHECK_SIZEOF([long]) 
# set fortran compiler
AC_LANG([Fortran])
AC_PROG_FC(ifx ifort gfortran,[])
#AC_FC_PP_DEFINE
#PP=$FC_DEFINE

#use empty program to check if cpp or fpp
#AC_MSG_CHECKING(Checking Preprocessor option -cpp)
#PPCMD="-cpp"
#FCFLAGS=$PPCMD
#AC_COMPILE_IFELSE([AC_LANG_PROGRAM([],[])],
#         [AC_MSG_RESULT(yes)],
#         [PPCMD="-fpp"
#          AC_MSG_RESULT([no, using $PPCMD])])
#FCFLAGS=" "

AC_PREFIX_DEFAULT(`pwd`)

#run gitinit to set hooks
./scripts/gitinit

#get git info
.githooks/git-create-revisioninfo-hook.sh

# Ceck for BINADD
AC_ARG_WITH([binadd],
  [AS_HELP_STRING([--with-binadd=string],
    [add string to output binaries])],
  [])
if test "x$with_binadd" != "x" ; then
  EXEADD=$EXEADD"."$with_binadd
fi

# Check MPI first. This might overwrite FC 
OMPI_FC=$FC
if test "x$with_mpi" != "x" ; then
case $FC in
  *ifx)
		MPIFC="mpi$FC"
		;;
  *ifort)
		MPIFC="mpifort"
		;;
	*gfortran)
		MPIFC="mpif90"
		;;
	*)
		echo "Unknown fortran compiler: $FC"
		exit
		;;
esac
else
	MPIFC=""
fi
AC_MSG_NOTICE([MPI Fortran compiler: $MPIFC])
MPICC=""
PP="-D"
AC_ARG_WITH([mpi],
  [AS_HELP_STRING([--with-mpi=DIR],
    [path to MPI distribution, defaults to /opt/local/mpi/openmpi])],
  [])
if test "x$with_mpi" != "x" ; then
   if test "x$with_mpi" = xyes ; then
      AC_PATH_PROG(mpiprog,$MPIFC)
if test "x$mpiprog" == "x" ; then
        with_mpi="/opt/local/mpi/openmpi/openmpi-4.0.5_gcc-4.8.5"
      else
        with_mpi=$(echo $mpiprog |awk -F"/bin/$MPIFC" '{print $1}')
      fi
      # #check if openmpi or mvapich
      # openmpi=$(echo $mpiprog | grep openmpi)
      # mvapich=$(echo $mpiprog | grep mvapich)
#     #  if test "x$openmpi" != "x0" ;then
#     #     MPILIB="-lmpi"
      # if  test "x$mvapich" != "x0" ;then
      #    MPILIB="-lmpich"
			# else
		# 		MPILIB="-lmpi"
    #   fi
  		MPILIB="-lmpi"
   fi   
   AC_CHECK_FILE([${with_mpi}/bin/$MPIFC], [],     
                AC_MSG_ERROR($MPIFC compiler not found.))
   AC_MSG_NOTICE([MPI version])
   PPFLAGS=$PPFLAGS" "$PP"MPI"
   LPATH=$LPATH" -L$with_mpi/lib "
   IPATH=$IPATH" -I$with_mpi/include "
   HELIBS=$HELIBS" "$MPILIB 
   MPIFC=$with_mpi/bin/$MPIFC
   MPICC=$with_mpi/bin/mpicc
   EXEADD=$EXEADD".mpi"
   # #check if mpifort is using gfortran or ifort
   # impi=$($MPIFC --version | grep $FC)
   # gmpi=$($MPIFC --version | grep GNU )
   # FCOLD=$FC
   # if test "x$impi" != "x" ;then
   #    AC_MSG_NOTICE([MPI COMPILER: $impi])
   #    FC=ifort
   # elif test "x$gmpi" != "x" ;then
   #    AC_MSG_NOTICE([MPI COMPILER: $gmpi])
   #    FC=gfortran
   # else
   #    AC_MSG_ERROR([MPI version uses unknown compiler (only ifort or gfortran supported).])
   # fi
   # if test "$FCOLD" != "$FC" ;then
   #    AC_MSG_NOTICE([Changed fortran compiler: Using $FC])  
   #    AC_LANG([Fortran])
   #    AC_PROG_FC($FC)
	 # fi
fi
AC_MSG_NOTICE([Using fortran Compiler: $FC]) 

#check for debug option
AC_ARG_ENABLE(debug,  
AS_HELP_STRING([--enable-debug],
[enable debugging, default: no]),
[case "${enableval}" in
yes) debug=true ;;
no)  debug=false ;;
*)   AC_MSG_ERROR([bad value ${enableval} for --enable-debug]) ;;
esac],
[debug=false])
#AM_CONDITIONAL(DEBUG, test x"$debug" = x"true")

# optimization flags
AC_MSG_CHECKING(optimization and preprocessing flags)
case $FC in
  *ifort|*ifx)
    AR="ar"
#    OPTFLAGS="-O2 -save"
    if $debug ;then
      OPTFLAGS="-O0 -g3"
    else
 #      OPTFLAGS="-fast"
     OPTFLAGS="-O3"
    fi
    PPCMD="-fpp"
    EXEADD=".intel"$EXEADD
    PPFLAGS=$PPFLAGS" "$PP"INTEL"
    DISLINSUB="ifc"
  ;;
  *gfortran)
    #redefine preprocessing in override-specs.h
    PPCMD="-specs override-specs.h"
    PPFLAGS=$PPFLAGS" "$PP"GNU"
    FCFLAGS=" "
    AR="ar"
     if $debug ;then
      OPTFLAGS="-O3 -O4 -O5 -ffast-math "
    else
      OPTFLAGS="-O2 -g3 "
    fi
    gfortranversion=$(gfortran -dumpversion)
    gfortran10=$(echo "${gfortranversion%%.*}")
    if test $gfortran10 -ge 10 ;then
      OPTFLAGS=$OPTFLAGS" -fallow-argument-mismatch "
    fi
    EXEADD=".gfortran"$EXEADD
    DISLINSUB="gf"
    #test if preprocessor flag is -cpp or -fpp
  ;;
  *)
    AC_MSG_ERROR([helix: Don't know compiler $FC])
  ;;
esac
AC_MSG_RESULT([$OPTFLAGS])
AC_MSG_NOTICE([Preprocessor flag: $PPCMD])

AC_MSG_NOTICE([Using fortran Compiler: $FC]) 
AC_MSG_NOTICE([Using OPTFLAGS: $OPTFLAGS]) 


# check whether 64 or 32 bit
AS_IF([test "$ac_cv_sizeof_long" -eq 8], 
    [PPFLAGS=$PPFLAGS" "$PP"bit64" ; IDLPAR=" -m64"])

AC_SUBST(OPTFLAGS)
AC_SUBST(AR)
#
#AC_FC_SRCEXT([F90])
#AC_LANG([Fortran])

if test "x$with_mpi" == "x" ; then
   AC_MSG_NOTICE([Single CPU version])
#Check IDL flag, if not MPI
   AC_ARG_WITH([idl],
      [AS_HELP_STRING([--with-idl],[])],[])
   if test "x$with_idl" = "xyes" ; then
      AC_MSG_NOTICE([IDL version])
      PPFLAGS=$PPFLAGS" "$PP"IDL"
      FCFLAGS=$FCFLAGS$IDLPAR" -shared "
      if test `uname` != "in" ; then
         FCFLAGS=$FCFLAGS" -fPIC "
      fi
      HELIBS=$HELIBS" "
      SHAREDOBJ="compute_profile.so call_pikaia.so"
      MAKECMD="idlso"
      ADDCFITSIO=0
  else
#CHECK DISLIN if not IDL
  AC_ARG_WITH([dislin],
    [AS_HELP_STRING([--with-dislin=DIR],
    [path to DISLIN distribution, defaults to /usr/local/dislin])],
    [])
  if test "x$with_dislin" != "x" ; then
   if test "x$with_dislin" = xyes ; then
      with_dislin="/usr/local/dislin"
   fi
   AC_CHECK_FILE([$with_dislin/dislin.h], [], 
                 AC_MSG_ERROR([Include file dislin.h not found]))
   LPATH=$LPATH" -L$with_dislin"
   IPATH=$IPATH" -I$with_dislin"
   AC_CHECK_FILE([$with_dislin/$DISLINSUB/dislin.f90],
     [DISF90=$with_dislin/$DISLINSUB/dislin.f90
      DISOBJ=dislin.o
      AC_SUBST(DISF90)
      AC_SUBST(DISOBJ)],
     [AC_CHECK_FILE([$with_dislin/$DISLINSUB/dislin.mod],
      [LPATH=$LPATH" -L$with_dislin/$DISLINSUB"
       IPATH=$IPATH" -I$with_dislin/$DISLINSUB"],
      [AC_MSG_ERROR([dislin.f90 or dislin.mod not found.])])])
      HELIBS=$HELIBS" -ldislin"
      if test `uname` == "Darwin" ; then
         HELIBS=$HELIBS" -lXm -L/usr/local/lib/ -L/Library/Developer/CommandLineTools/SDKs/MacOSX.sdk/usr/lib "
      fi
     PPFLAGS=$PPFLAGS" "$PP"X11"
     AC_MSG_NOTICE([X11 (DISLIN) version])
  fi
  fi
fi


#replace FC, CC for mpi version
if test "x$MPIFC" != "x" ;then
  FC=$MPIFC
fi
if test "x$MPICC" != "x" ;then
  CC=$MPICC
fi

# Check CFITSIO library
AC_ARG_WITH([cfitsio], [AS_HELP_STRING([--with-cfitsio=DIR],
            [directory containing cfitsio directory, defaults to /])], [])
if test "x$with_cfitsio" = "x" || test "x$with_cfitsio" = "xyes" ; then
   AC_CHECK_LIB(cfitsio,ftopen,[fitsio=1],[fitsio=0])
fi
ADDCFITSIO=1
if test "$fitsio" != "1" ; then
  if test "x$with_cfitsio" = "x" || test "x$with_cfitsio" = "xyes" ; then
     with_cfitsio="$PWD/cfitsio"
  fi
  with_cfitsio_include_path="$with_cfitsio/include"
  AC_CHECK_FILE([${with_cfitsio_include_path}/fitsio.h], [ok=1], [ok=0])
  if test "$ok" == "0" ;then
    with_cfitsio_include_path="$with_cfitsio"
    AC_CHECK_FILE([${with_cfitsio_include_path}/fitsio.h], [],
         AC_MSG_ERROR([Include file ${with_cfitsio_include_path}/fitsio.h not found]))
  fi
  with_cfitsio_lib_path="$with_cfitsio/lib"
  AC_CHECK_FILE([${with_cfitsio_lib_path}/libcfitsio.a], [ok=1], [ok=0])
  if test "$ok" == "0" ;then
    with_cfitsio_lib_path="$with_cfitsio"
    AC_CHECK_FILE([${with_cfitsio_lib_path}/libcfitsio.a], [ok=1],
                AC_MSG_ERROR([Library file libcfitsio.a not found]))
  fi
  IPATH=" -I$with_cfitsio_include_path "$IPATH
  LPATH=" -L$with_cfitsio_lib_path "$LPATH
  AC_MSG_NOTICE([CFITSIO Libraries: $with_cfitsio_lib_path])
  AC_MSG_NOTICE([CFITSIO Include: $with_cfitsio_include_path])
fi

#module load openmpi_gcc


AC_PROG_RANLIB
AC_SUBST(RANLIB)
AC_SUBST(PPFLAGS)
AC_SUBST(PPCMD)


#common libraries
HELIBS=$HELIBS" -lodr "
if test "x$ADDCFITSIO" = "x1" ; then
  HELIBS=$HELIBS" -lcfitsio"
fi
LIBS=$HELIBS
AC_MSG_NOTICE([Libraries: $LIBS])

LPATH=$LPATH" -L`pwd`/fortran/odrpack "
IPATH=$IPATH" -I`pwd`/fortran/odrpack "

AC_SUBST(LPATH)
AC_SUBST(IPATH)
AC_SUBST(LIBS)

BINARY=$EXE$EXEADD
BINTEST="mpitest"$EXEADD
BINADD=$binadd
AC_SUBST(BINARY)
AC_SUBST(BINTEST)
AC_SUBST(BINDIR)
AC_SUBST(SHAREDOBJ)
AC_SUBST(MAKECMD)


AC_CONFIG_FILES([
Makefile
fortran/odrpack/Makefile
fortran/src/Makefile
])
AC_OUTPUT
